function StartGhostFire(%pos) {
	%Ghost = new player(){
	   Datablock = "GhostFireArmor";
	};
   %Ghost.setTransform(%pos);
   %Ghost.team = $zombie::team;
   %Ghost.hastarget = 1;
   %Ghost.isGOF = 1;
   MissionCleanup.add(%Ghost);
   %Ghost.target = createTarget(%Ghost, "The Ghost Of Fire", "", "Male3", '', %Ghost.team, PlayerSensor);
   setTargetSensorData(%Ghost.target, PlayerSensor);
   setTargetSensorGroup(%Ghost.target, 0);
   setTargetName(%Ghost.target, addtaggedstring("\c7The Ghost Of Fire"));
   GOFConsiderFlamethrowerAttack(%Ghost);
   GOFDoRandomAttacks(%ghost);
   schedule(1,0,"StartBossMusic","GOF", %Ghost);
   schedule(500,0,"GOFLookforTarget", %Ghost);
}

function GOFLookforTarget(%Ghost) {
   if(!isObject(%Ghost))
	return;
   if(%Ghost.getState() $= "dead")
	return;
   %pos = %Ghost.getposition();
   %wbpos = %Ghost.getworldboxcenter();
   %count = ClientGroup.getCount();
   %closestClient = -1;
   %closestDistance = 32767;
   for(%i = 0; %i < %count; %i++) {
	%cl = ClientGroup.getObject(%i);
	if(isObject(%cl.player)){
	   %testPos = %cl.player.getWorldBoxCenter();
	   %distance = vectorDist(%wbpos, %testPos);
	   if (%distance > 0 && %distance < %closestDistance) {
	   	%closestClient = %cl;
	   	%closestDistance = %distance;
	   }
	}
   }
   if(%closestClient) {
       GOFPerformMove(%Ghost,%closestClient,%closestDistance);
   }
   %Ghost.Targeting = schedule(500, %Ghost, "GOFLookforTarget", %Ghost);
}

function GOFPerformMove(%ghost,%closestClient,%closestDistance) {
   %ghost.TargetCL = %closestClient;
   %ghost.DistToTarg = %closestDistance;
   %zposition = %ghost.getPosition();
   %Zzaxis = getword(%zposition,2);
   if(%Zzaxis < $zombie::falldieheight) {
   %ghost.scriptkill($DamageType::Suicide);
   }
   %pos = %ghost.getworldboxcenter();
   %closestClient = %closestClient.Player;
   if(%closestDistance <= $zombie::detectDist){
	if(%ghost.hastarget != 1){
	   %ghost.hastarget = 1;
	}
 
    //target is coming in for an easy kill, lets tele
    if(%closestDistance < 15) {
       BurnTeleport(%ghost);
    }

	%clpos = %closestClient.getPosition();
      %vector = vectorNormalize(vectorSub(%clpos, %pos));
	%v1 = getword(%vector, 0);
	%v2 = getword(%vector, 1);
	%nv1 = %v2;
	%nv2 = (%v1 * -1);
	%none = 0;
	%vector2 = %nv1@" "@%nv2@" "@%none;
	%ghost.setRotation(fullrot("0 0 0",%vector2));

	%fmultiplier = $Zombie::ForwardSpeed;
	%vector = vectorscale(%vector, %Fmultiplier);
	%upvec = "150";

	%x = Getword(%vector,0);
	%y = Getword(%vector,1);
	%z = Getword(%vector,2);
	if(%z >= 600)
	   %upvec = (%upvec * 5);
	%vector = %x@" "@%y@" "@%upvec;
	%ghost.applyImpulse(%pos, %vector);
   }
}


//ATTACKS
function GOFConsiderFlamethrowerAttack(%g) {
   if(!isObject(%g) || %g.getState() $= "dead") {
      return;
   }
   %target = %g.TargetCL;
   %distance = %g.DistToTarg;
   if(isObject(%target.player) && %target.player.getState() !$= "dead") {
      //We have a target, time to scan distance
      if(%distance <= 35) {
         //The idiot is in range, crisp em :)
         %vec = vectorsub(%target.player.getworldboxcenter(),%g.getMuzzlePoint(0));
         %vec = vectoradd(%vec, vectorscale(%target.player.getvelocity(),vectorlen(%vec)/100));
         %p = new LinearFlareProjectile() {
             dataBlock        = FlameboltMain; //burn :)
             initialDirection = %vec;
             initialPosition  = %g.getMuzzlePoint(0);
             sourceObject     = %g;
             sourceSlot       = 0;
         };
         schedule(200,0,"GOFConsiderFlamethrowerAttack",%g);
      }
      else {
         schedule(750,0,"GOFConsiderFlamethrowerAttack",%g);
      }
   }
   //no target, lets use a longer loop
   else {
      schedule(750,0,"GOFConsiderFlamethrowerAttack",%g);
   }
}

function ThrowFireBall(%g, %t) {
   if(!isObject(%t) || %t.getState() $= "dead") {
      return;
   }
   if(!isObject(%g) || %g.getState() $= "dead") {
      return;
   }
   %vec = vectorsub(%t.getworldboxcenter(),%g.getMuzzlePoint(0));
   %vec = vectoradd(%vec, vectorscale(%t.getvelocity(),vectorlen(%vec)/100));
   %p = new LinearProjectile() {
       dataBlock        = NapalmShot; //burn :)
       initialDirection = %vec;
       initialPosition  = %g.getMuzzlePoint(0);
       sourceObject     = %g;
       sourceSlot       = 0;
   };
}

function CreateFireBlast(%g, %pos) {
   if(!isObject(%g) || %g.getState() $= "dead") {
      return;
   }
   %p = new TracerProjectile() {
	   	dataBlock        = napalmSubExplosion;
	   	initialDirection = "0 0 -10";
	   	initialPosition  = %pos;
	   	sourceObject     = %g;
   	   	sourceSlot       = 5;
   };
   %p.vector = "0 0 -10";
   %p.count = 1;
}

function BurnTeleport(%g) {
   if(!isObject(%g) || %g.getState() $= "dead") {
      return;
   }
   %cP = %g.getPosition();
   %nP = getRandomPosition(55,0);
   %nP2 = vectorAdd(%np, "0 0 100");
   %fP = vectorAdd(%cP, %nP2);
   CreateFireBlast(%g, %cP);
   %g.setTransform(%fP);
   messageall('TheFireMsg',"\c4The Ghost Of Fire: ehehehehe.. Burn out...");
}

function GOFDoRandomAttacks(%g) {
   if(!isObject(%g) || %g.getState() $= "dead") {
      return;
   }
   %rand = getRandom(1,4);
   %target = FindValidTarget(%g);
   switch(%rand) {
      case 1:
         if(isObject(%target.player)) {
         CreateFireBlast(%g, %target.player.getPosition());
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Time to heat things up "@getTaggedString(%target.name)@".");
         }
         else {
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Frightened of my fire? Good.");
         }
      case 2:
         if(isObject(%target.player)) {
         ThrowFireBall(%g, %target.player);
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Lets see how you dodge this, "@getTaggedString(%target.name)@".");
         }
         else {
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Frightened of this? Good.");
         }
      case 3:
         if(isObject(%target.player)) {
         ThrowFireBall(%g, %target.player);
         schedule(400,0,"ThrowFireBall", %g, %target.player);
         schedule(800,0,"ThrowFireBall", %g, %target.player);
         schedule(1200,0,"ThrowFireBall", %g, %target.player);
         schedule(1600,0,"ThrowFireBall", %g, %target.player);
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Flame Storm "@getTaggedString(%target.name)@", cooked up nicely for you.");
         }
         else {
         messageall('TheFireMsg',"\c4The Ghost Of Fire: I love Fire.. it's Good your scared.");
         }
      case 4:
         if(isObject(%target.player)) {
         CreateFireBlast(%g, vectorAdd(%target.player.getPosition(), "0 0 25"));
         schedule(400,0,"ThrowFireBall", %g, vectorAdd(%target.player.getPosition(), "0 0 30"));
         schedule(800,0,"ThrowFireBall", %g, vectorAdd(%target.player.getPosition(), "0 0 35"));
         schedule(1200,0,"ThrowFireBall", %g, vectorAdd(%target.player.getPosition(), "0 0 40"));
         schedule(1600,0,"ThrowFireBall", %g, vectorAdd(%target.player.getPosition(), "0 0 45"));
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Engage Dictator Strike!!!");
         }
         else {
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Frightened Of Fire? Good.");
         }
      default:
         if(isObject(%target.player)) {
         CreateFireBlast(%g, %target.player.getPosition());
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Time to heat things up "@getTaggedString(%target.name)@".");
         }
         else {
         messageall('TheFireMsg',"\c4The Ghost Of Fire: Frightened? Good.");
         }
   }
   schedule(25000,0,"GOFDoRandomAttacks", %g);
}
